/*******************************************************************************

  Copyright (c) 2001-2004, Intel Corporation
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
  
   1. Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
  
   2. Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
  
   3. Neither the name of the Intel Corporation nor the names of its
      contributors may be used to endorse or promote products derived from
      this software without specific prior written permission.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.

*******************************************************************************/

/*$FreeBSD$*/

#ifndef _IXGB_IDS_H_
#define _IXGB_IDS_H_

/**********************************************************************
** The Device and Vendor IDs for 10 Gigabit MACs
**********************************************************************/

#define INTEL_VENDOR_ID         0x8086
#define INTEL_SUBVENDOR_ID      0x8086


#define IXGB_DEVICE_ID_82597EX      0x1048   /* Cibolo A1, -LR (1310nm) */
#define IXGB_DEVICE_ID_82597EX_SR   0x1A48   /* Cibolo B0, -SR (850nm)  */

#define IXGB_SUBDEVICE_ID_A11F  0xA11F   /* Adapter-OEM-1310nm-Fiber */
#define IXGB_SUBDEVICE_ID_A01F  0xA01F   /* Adapter-Retail-1310nm-Fiber */

#define IXGB_SUBDEVICE_ID_A15F  0xA15F   /* Adapter-OEM-850nm-Fiber */
#define IXGB_SUBDEVICE_ID_A05F  0xA05F   /* Adapter-Retail-850nm-Fiber */

#define IXGB_SUBDEVICE_ID_A12F  0xA12F   /* Adapter-OEM-1310nm-Fiber */
#define IXGB_SUBDEVICE_ID_A02F  0xA02F   /* Adapter-Retail-1310nm-Fiber */

#endif /* #ifndef _IXGB_IDS_H_ */

/* End of File */
